unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PixelsGeel: TEdit;
    Label1: TLabel;
    PixelsAnders: TEdit;
    Label2: TLabel;
    PixelsBlauw: TEdit;
    Label4: TLabel;
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    Timer2: TTimer;
    Edit1: TEdit;
    Label3: TLabel;
    Memo1: TMemo;
    Label5: TLabel;
    Button1: TButton;
    Edit2: TEdit;
    procedure FormActivate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure ScanCanvas;
    procedure GrabFrame;
    procedure FormCreate(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
     hWndC : THandle;
  public

  end;

var
  Form1: TForm1;
  scan, gezien : integer;

implementation
{$R *.DFM}
{functie uit avicap32.dll}
 function capCreateCaptureWindowA(lpszWindowName : PCHAR; dwStyle : longint;
           x : integer; y : integer; nWidth : integer; nHeight :integer;
            ParentWin : HWND; nId : integer)
            : HWND; STDCALL EXTERNAL 'AVICAP32.DLL';


procedure TForm1.FormActivate(Sender: TObject);
begin
PixelsGeel.Text := '';
PixelsBlauw.Text := '';
PixelsAnders.Text := '';
scan := 0;
gezien := 0;
StatusBar1.Panels[1].Text := 'Versie 1.1 19-09-2000' ;
StatusBar1.Panels[2].Text := 'www.trainchecker.com';
Memo1.Clear;
end;

procedure TForm1.ScanCanvas;
var
BitMap : TBitmap;
x,y,a : integer;
checkg,checkb,ander : integer;
geel,rood,blauw,groen,blw : integer;
x1,x2,y1,y2,z,b,odd : integer;
begin
geel := 0;
blw :=0;
ander := 0;
x1 := 80;
x2 := 180;
y1 := 50;
y2 := 90;
odd := 0;
y := y2;
BitMap := TBitMap.create;
BitMap.LoadFromFile('c:\train.bmp');
canvas.draw(0,0,BitMap);
for x := x1 to x2 do
  begin
      if odd = 1 then
      y := y-1;
      for z := y1 to y2 do
      begin
        checkg := 0;
        checkb := 0;
        b := z + y;
        a := canvas.Pixels[x,b];
        canvas.Pixels[x,b] := 0;
// maskeren van de kleuren voor het checken van RGB
        rood := (a and $000000FF);
        groen := (a and $0000FF00);
        blauw := (a and $00FF0000);
// geel checken
        if (rood >= 104) and (rood <= 256)then
        checkg := checkg + 1;
        if (groen >= 37000) and (groen <= 65535)then
        checkg := checkg + 1;
        if (blauw >= 65536) and (blauw <= 9502727)then
        checkg := checkg + 1;
// blauw checken
        if (rood >= 0) and (rood <= 80)then
        checkb := checkb + 1;
        if (groen >= 17000) and (groen <= 28000)then
        checkb := checkb + 1;
        if (blauw >= 65536) and (blauw <= 9502727)then
        checkb := checkb + 1;
// check checken
        if checkg = 3 then
        geel := geel + 1
        else if checkb = 3 then
        blw := blw + 1
        else
        ander := ander + 1;
      end;
   if odd = 0 then
      odd := 1
      else if odd = 1 then
      odd := 0;
  end;
PixelsGeel.Text := IntToStr(geel);
PixelsBlauw.Text := IntToStr(blw);
PixelsAnders.Text := IntToStr(ander);
scan := scan + 1;
Edit1.Text := IntToStr(scan);
Edit2.Text := ColorToString(canvas.pixels[90,60]);
if (geel >= (350- (0.5*blw))) and (gezien = 0) then   // geel >= 200
begin
Memo1.Lines.Add(' Er is een Trein gezien om ' +  TimeToStr(Time) + ' op de dag ' + FormatDateTime('dd-mm-yyyy',Date) );
gezien := 1;
end
else if (geel >= 200) then
gezien := 1
else
gezien := 0;

BitMap.Destroy;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
StatusBar1.Panels[0].Text := FormatDateTime('dd-mm-yyyy',Date) + '  ' + TimeToStr(Time);
end;

{als het programma wordt gesloten wordt ook de connectie met de driver gesloten}
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SendMessage(hWndC,WM_USER + 11, 0, 0); //WM_CAP_DRIVER_DISCONNECT
end;

{functie om een frame te krijgen in panel1}
procedure TForm1.grabframe;
begin
  sendmessage(hWndC, WM_USER + 60,1,1);
  SendMessage(hWndC,WM_USER+25,0,longint(pchar('c:\train.bmp')));
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
Memo1.Lines.Add(' Er is een Trein gezien om ' +  TimeToStr(Time) + ' op de dag ' + FormatDateTime('dd-mm-yyyy',Date) );
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
hWndC := capCreateCaptureWindowA('trein', WS_Child, 0, 0, 320, 240, Form1.Handle, 0);
   if hWndC <> 0 then
     SendMessage(hWndC,WM_USER + +10, 0, 0); //WM_CAP_DRIVER_CONNECT

end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
GrabFrame();
ScanCanvas();
end;

end.









